	program cnhistmn
C Monthly mean histogra for total period
C
C.....................................................May 2014
C Count histogram of occurremce of W=-4,-3,-2,-1,0,1,2,3,4
C                               ihist 1  2  3  4 5 6 7 8 9
C  
C
C JPL maps  in MLATxMLON format
C
C for mlat=-85:5:85, mlong=0:5:360  (35mlas x 72mlons = 2520 grids)
C subset : mlats=-85,-80,-75,-70,-65,-60 (lines 1,2,...,6) South (432 grids)
C subset : mlats=60,65,70,75,80,85 (lines 30,31,...,35) North	   (432 grids)
c from hourly maps
c
	DIMENSION 
	+ hist(9,12)  ! ihist(j,mn) j~9 values of W, mn=1,...,12; 
	+,hists(9,12)  ! ihist(j,mn) j~9 values of W, mn=1,...,12; South
	+,histn(9,12)  ! ihist(j,mn) j~9 values of W, mn=1,...,12; North
	+,xres(9),xress(9),xresn(9),res(9),ress(9),resn(9)
	 INTEGER*2 IYR
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64 outfile,outfiles,outfilen,out1,out2,out3 
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C start
	 cntot=0.
	cntots=0.
	cntotn=0.
	do i=1,9
	xres(i)=0.
	xress(i)=0.
	xresn(i)=0.
	enddo
      outfile='histwm.txt'	! W-indices from W-maps geomag.coord.
	outfiles='histwms.txt'	! W-indices from W-maps geomag.coord.South
	outfilen='histwmn.txt'	! W-indices from W-maps geomag.coord.North
  	OPEN(112,FILE=OUTFILE)		!input
  	OPEN(113,FILE=OUTFILES)		!input
  	OPEN(114,FILE=OUTFILEN)	  	!input
	out1='histmon.txt'
	out2='histmons.txt'
	out3='histmonn.txt'
  	OPEN(115,FILE=OUT1,access='APPEND')		
  	OPEN(116,FILE=OUT2,access='APPEND')		
  	OPEN(117,FILE=OUT3,access='APPEND')	  	
C
	do i=1,9
	res(i)=0.
	ress(i)=0.
	resn(i)=0.
	do k=1,12
	hist(i,k)=0.
	hists(i,k)=0.
	histn(i,k)=0.
	enddo
	enddo

	DO 501 kk=1,15 ! years
C start cycle on month ---------------------------------
	DO 400 imn=1,13
 13   FORMAT(I2)
   72 format(1X,2I2,9(1X,F6.2))
C ===== Input datafile 
c	pause ' '
    1	READ (112,72,END=3,ERR=2) iyr,mn,(res(k),k=1,9) 
      READ (113,72,END=3,ERR=2) iyr,mn,(ress(k),k=1,9) 
	READ (114,72,END=3,ERR=2) iyr,mn,(resn(k),k=1,9) 
C
	if (imn.eq.13) then
	write(*,72) iYR,imn,(res(k),k=1,9)			! annual %
	write(115,72) iYR,imn,(res(k),k=1,9)
	write(*,72) iYR,imn,(ress(k),k=1,9)			! annual % South
	write(116,72) iYR,imn,(ress(k),k=1,9)
	write(*,72) iYR,imn,(resn(k),k=1,9)			! annual % North
	write(117,72) iYR,imn,(resn(k),k=1,9)
	goto 400
	endif

	do n=1,9
	hist(n,mn)=hist(n,mn)+res(n)
c		South:
	hists(n,mn)=hists(n,mn)+ress(n)
c		North:
	histn(n,mn)=histn(n,mn)+resn(n)
	enddo
400	CONTINUE
  501	continue
    3	do mn=1,12
	do n=1,9
  	res(n)=hist(n,mn)/15. 
	ress(n)=hists(n,mn)/15. 
	resn(n)=histn(n,mn)/15. 
	enddo
	write(*,72) iYR,mn,(res(k),k=1,9)			! annual %
	write(115,72) iYR,mn,(res(k),k=1,9)
	write(*,72) iYR,mn,(ress(k),k=1,9)			! annual % South
	write(116,72) iYR,mn,(ress(k),k=1,9)
	write(*,72) iYR,mn,(resn(k),k=1,9)			! annual % North
	write(117,72) iYR,mn,(resn(k),k=1,9)
	enddo
C----------------------------------------------------------
	CLOSE(unit=112)
	CLOSE(unit=113)
	CLOSE(unit=114)
	CLOSE(unit=115)
	CLOSE(unit=116)
	CLOSE(unit=117)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

