	program cnhistwm
C.....................................................May 2014
C Count histogram of occurremce of W=-4,-3,-2,-1,0,1,2,3,4
C                               ihist 1  2  3  4 5 6 7 8 9
C  
C
C JPL maps  in MLATxMLON format
C
C for mlat=-85:5:85, mlong=0:5:360  (35mlas x 72mlons = 2520 grids)
C subset : mlats=-85,-80,-75,-70,-65,-60 (lines 1,2,...,6) South (432 grids)
C subset : mlats=60,65,70,75,80,85 (lines 30,31,...,35) North	   (432 grids)
c from hourly maps
c
	DIMENSION IDHR(0:71),IM(12)
	+,ihist(9,12)  ! ihist(j,mn) j~9 values of W, mn=1,...,12; 
	+,ihists(9,12)  ! ihist(j,mn) j~9 values of W, mn=1,...,12; South
	+,ihistn(9,12)  ! ihist(j,mn) j~9 values of W, mn=1,...,12; North
	+,iwyr(9) ! cnt annual ~9 values of W
	+,iwyrs(9) ! cnt annual ~9 values of W South
	+,iwyrn(9) ! cnt annual ~9 values of W North
	+,iwp(9),xres(9),xress(9),xresn(9),res(9),ress(9),resn(9)
	 INTEGER*2 IYR,IMN,IDY,idy1,idy2,iut,kyr,iyr0
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64,infile,outfile,outfiles,outfilen
	CHARACTER*2 AYR,AMN,AUT,ADY,CC
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA IWP/-4,-3,-2,-1,0,1,2,3,4/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C start
	CC='  '
	 cntot=0.
	cntots=0.
	cntotn=0.
	do i=1,9
	iwyr(i)=0.
	iwyrs(i)=0.
	iwyrn(i)=0.
	enddo
      outfile='histwm.txt'	! W-indices from W-maps geomag.coord.
	outfiles='histwms.txt'	! W-indices from W-maps geomag.coord.South
	outfilen='histwmn.txt'	! W-indices from W-maps geomag.coord.North
  	OPEN(112,FILE=OUTFILE,access='APPEND')
  	OPEN(113,FILE=OUTFILES,access='APPEND')
  	OPEN(114,FILE=OUTFILEN,access='APPEND')

c-      WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
c-      READ(*,'(A)') AYEAR
C
C start cycle on uear: =====================================
C
	iyear0=1998
	iyr0=98
C
	DO 400 kyr=1,15
ctemp	kyr=15
	iyr=iyr0+kyr
	if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,AYR)

crem	
	xmap=2520.
	xmaps=432.
	xmapn=432.
	year=float(iyr)
	if(int(year/4.)*4.eq.iyr) THEN 
	ndnr=366
	im(2)=29
	cntwyr=xmap*24*366.  
	cntwyrs=xmaps*24*366.  
	cntwyrn=xmapn*24*366.  
	                          ELSE
	ndnr=365
	im(2)=28
	cntwyr=xmap*24*365.  
	cntwyrs=xmaps*24*365.  
	cntwyrn=xmapn*24*365.  
	ENDIF
	cntot=cntot+cntwyr
	cntots=cntots+cntwyrs
	cntotn=cntotn+cntwyrn
	cntmon=0.
	cntmons=0.
	cntmonn=0.
	do i=1,9
	res(i)=0.
	ress(i)=0.
	resn(i)=0.
	do k=1,12
	ihist(i,k)=0.
	ihists(i,k)=0.
	ihistn(i,k)=0.
	enddo
	enddo
C start cycle on month ---------------------------------
	DO 401 imn=1,12
c-      WRITE(*,'(\A\)') ' ENTER MONTH OF INPUT FILE='
c-      READ(*,'(A)') AMN
	call blet2(imn,AMN)
      
c-	WRITE(*,'(\A\)') ' ENTER DY1 & DY2 ='
c-      READ(*,13) idy1,idy2
 13   FORMAT(I2)
	idy1=1
	idy2=im(imn)
CC CALCULATION OF DAYS OF YEAR	
      infile='d:\web\dwm\YR\MN\wmMNDYUT.jYR' ! JPL W(mlat & mlong map)
  	infile(12:13)=ayr
	infile(15:16)=amn
  	infile(28:29)=ayr
	infile(20:21)=amn
C
 198	format(4X,A2,24(3X,A2),3X,A4)
C
	mndy=idy2
	cntmon=xmap*24.*float(mndy)
	cntmons=xmaps*24.*float(mndy)
	cntmonn=xmapn*24.*float(mndy)
  130	format(A133)

C
C
CC  
  197 continue
C
C  day-to-day cycle
C ========================================

       DO 500 idy=idy1,idy2
	lda=ndoy(iyr,mn,idy)  ! day-of-year
	call blet2(idy,ady)
	infile(22:23)=ady
C
C
C cycle on UT:
C -----------------------------------------------------
      DO 801 iut=0,23		! cycle on UT
	call blet2(iut,aut)
	infile(24:25)=aut
	OPEN(111,FILE=INFILE)
c
C ===== Input datafile 
 1311	DO 1799 jj=1,35	  ! mlats= -85:5:85
c	pause ' '
    1	READ (111,12,END=3,ERR=2) (IDHR(k),k=0,71) ! W(longs=-180:5:175)
  12	FORMAT(72(1X,I4))
C
	  DO k=0,71				! Cycle on Longi	 <<<<<<<<
C++ Count histogram indices W:
	do n=1,9
C total map
	if (idhr(k).eq.iwp(n)) then
	ihist(n,imn)=ihist(n,imn)+1
      iwyr(n)=iwyr(n)+1
c		South:
	if (jj.lt.7) then
	ihists(n,imn)=ihists(n,imn)+1
      iwyrs(n)=iwyrs(n)+1
	endif
c		North:
	if (jj.gt.29) then
	ihistn(n,imn)=ihistn(n,imn)+1
      iwyrn(n)=iwyrn(n)+1
	endif
C
	exit
	endif
	enddo
	 ENDDO		    ! Cycle on Longi	 >>>>>>>>>>>>>
 1799	CONTINUE				   ! Cycle jj on glats (total W map)
  3   CLOSE(unit=111)

C----------------------------------------------------------
  801 continue            ! end cycle on UT 


C
  500	CONTINUE ! next day
	do ii=1,9
	perc=0.
	percs=0.
	percn=0.
	if (cntmon.gt.0.) perc=float(ihist(ii,imn))/cntmon*100.
	if (cntmons.gt.0.) percs=float(ihists(ii,imn))/cntmons*100.
	if (cntmonn.gt.0.) percn=float(ihistn(ii,imn))/cntmonn*100.
	xres(ii)=perc
	xress(ii)=percs
	xresn(ii)=percn
	enddo
	write(*,72) AYR,AMN,(xres(k),k=1,9)       ! monthly %
	write(112,72) AYR,AMN,(xres(k),k=1,9)
	write(*,72) AYR,AMN,(xress(k),k=1,9)       ! monthly % South
	write(113,72) AYR,AMN,(xress(k),k=1,9)
	write(*,72) AYR,AMN,(xresn(k),k=1,9)       ! monthly % North
	write(114,72) AYR,AMN,(xresn(k),k=1,9)
C
  401	CONTINUE ! next month
C
C Annual hist
	do ii=1,9
	res(ii)=0.
	ress(ii)=0.
	resn(ii)=0.
	do mm=1,12
	res(ii)=res(ii)+float(ihist(ii,mm))
	ress(ii)=ress(ii)+float(ihists(ii,mm))
	resn(ii)=resn(ii)+float(ihistn(ii,mm))
	enddo
	perc=0.
	percs=0.
	percn=0.

      if (cntwyr.gt.0.) perc=res(ii)/cntwyr*100. 
      if (cntwyrs.gt.0.) percs=ress(ii)/cntwyrs*100. 
      if (cntwyrn.gt.0.) percn=resn(ii)/cntwyrn*100. 
	xres(ii)=perc
	xress(ii)=percs
	xresn(ii)=percn
	enddo

	write(*,72) AYR,CC,(xres(k),k=1,9)			! annual %
	write(112,72) AYR,CC,(xres(k),k=1,9)
	write(*,72) AYR,CC,(xress(k),k=1,9)			! annual % South
	write(113,72) AYR,CC,(xress(k),k=1,9)
	write(*,72) AYR,CC,(xresn(k),k=1,9)			! annual % North
	write(114,72) AYR,CC,(xresn(k),k=1,9)
  400	CONTINUE ! next year

	do ii=1,9
	perc=0.
	percs=0.
	percn=0.
      if (cntot.gt.0.) perc=float(iwyr(ii))/cntot*100. 
	if (cntots.gt.0.) percs=float(iwyrs(ii))/cntots*100. 
	if (cntotn.gt.0.) percn=float(iwyrn(ii))/cntotn*100. 
	xres(ii)=perc
	xress(ii)=percs
	xresn(ii)=percn
	enddo
	CC='99'
	write(*,72) CC,AYR,(xres(k),k=1,9)	! total %
	write(112,72) CC,AYR,(xres(k),k=1,9)	! total %
	write(*,72) CC,AYR,(xress(k),k=1,9)	! total %	 South
	write(113,72) CC,AYR,(xress(k),k=1,9)	! total % 
	write(*,72) CC,AYR,(xresn(k),k=1,9)	! total %	 North
	write(114,72) CC,AYR,(xresn(k),k=1,9)	! total %
   72 format(1X,2A2,9(1X,F6.2))
ct   75 continue	 	  ! <<<<<<<<<<<<<<<<<<
	CLOSE(unit=112)
	CLOSE(unit=113)
	CLOSE(unit=114)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

