      program solphasw
C.......................................................June 2014
C
C
	dimension RMIN(3),RMAX(3),SSN(12)
	character*64 infile, outfile
	integer*2 iyr,imn
	character*4 AYR
	character*2 AMN
	DATA RMIN/1996.9,2008.9,2019.7/
	DATA RMAX/1989.6,2000.3,2014.0/
 
	infile='catwxx.hrs'
	outfile='solphasw.res'
       	OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
C
C
C Cycle on 4 Catalogs:
C
	DO 180 icase=1,4
	irun=0
	if (icase.eq.1) INFILE(5:6)='un'   !'wmYRun.txt'
	if (icase.eq.2) INFILE(5:6)='ln'   !'wmYRln.txt'
	if (icase.eq.3) INFILE(5:6)='us'   !'wmYRus.txt'
	if (icase.eq.4) INFILE(5:6)='ls'   !'wmYRls.txt'
	write(*,*) infile
		write(12,*) infile
 	OPEN(11,FILE=INFILE)
  121 FORMAT(A4,12(2X,F4.1))
  122	FORMAT(1X,A2)
  123	FORMAT(12(3X,I4))
C Cycle on years 1999-2013
   74	FORMAT(1X,A2,12(1X,F4.0))

       do KK=1,15     !======== Yr-by-YR
	annsum=0.
	anssn=0.
	READ (11,74,END=3,ERR=2) AYR,(SSN(k),k=1,12)
	read(ayr,*) ryr
	iyr=int(ryr)
C  Cycle on mn
	do imn=1,12				!<<<<<<<<
	call blet2(imn,AMN)
	rmn=float(imn)
	ASTR=ryr+rmn/12.
	if(iyr.lt.30) then
	ASTR=ASTR+2000.
	else
	ASTR=ASTR+1900.
	endif
C Select Sol Phase boundaries
	do j=1,3				 !++++++++++
	if ((ASTR.le.RMIN(j)).and.(ASTR.ge.RMAX(j))) then
	AMIN=RMIN(j)
	AMAX=RMAX(j)
crem	exit
	endif
	if ((ASTR.ge.RMIN(j)).and.(ASTR.le.RMAX(j+1))) then
	amin=RMIN(j)
	amax=rmax(j+1)
crem	exit
	endif
	enddo
       FI=(ASTR-AMIN)/(AMAX-AMIN)
  150 write(*,13) AYR,AMN,fi,ssn(imn)
	write(12,13) AYR,AMN,fi,ssn(imn)
  13  FORMAT(1X,A4,A2,1X,F7.2,1X,F6.1)
      enddo					   ! end cycle on month
c	write(*,13) AYR,AMN,fi,anssn
c	write(12,13) AYR,AMN,fi,anssn
	ENDDO					   ! end cycle on year
    3	CLOSE(unit=11)
	goto 180
    2	write(*,*) 'input error'
	
180   continue
	CLOSE(unit=12)
	pause ' '
      STOP
	end