C........................................................Apr. 2014
C Input: YYMMDDfluxtable.txt (cov); rz=0.73*cov-17.8
C 
C........................................................Jan. 2014
C Produce proxy covp and proxy rzp 
C
C
C T.L.Gulyaeva...........................................Dec 2013
C
C Arrange daily update of APRZ.dat file
C  
C
C Input files
C         d:/apkp/aprz.dat  =outfile
C         d:/web/graf/kpyr.txt
C		d:/web/graf/YEAR/MN/YYMMDDfluxtable.txt

C
C <<< to replace -11 by Rz daily
C 
C Output: apfaver.txt
C
      PROGRAM addaprz3
C---------------------------------------------------------------
C
C
C
C*********TEST
	integer iap(0:7),ikp(0:7)
	dimension rz3(0:3),cv3(0:3),rzp(0:82),cvp(0:82)
	CHARACTER*128 INFILE1,INFILE2,OUTFILE,text
c+	+,outfilep
	 CHARACTER*41 txt,res(35000)
	CHARACTER*2 ayr,amn,ady,byr,bmn,bdy,cyr,cmn,cdy,aut
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ,covi
	CHARACTER*3 rzi
	CHARACTER*9 yymmdd
C
c
	      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
	cyr=DD(3:4)
	cmn=dd(5:6)
	cdy=dd(7:8)
C
	outfile='d:/apkp/aprz.dat'  ! input file
c+	outfilep='aprzp.out'  ! output file with proxies: date, cv,cv3,cvb7,cvb81,cvp,rz,rz3,rzb7,rzb81,rzp
	infile1='d:/web/graf/2014/kpyr.txt'
	infile1(15:16)=cyr
	infile1(20:21)=cyr

	infile2='d:/web/graf/20YR/MN/yrmndyfluxtable.txt'
	infile2(15:16)=cyr
	infile2(18:19)=cmn
	infile2(21:22)=cyr
	infile2(23:24)=cmn
	infile2(25:26)=cdy

	OPEN(10,FILE=outfile)
	OPEN(11,FILE=infile1,action='READ')
	OPEN(12,FILE=infile2,action='READ')
c+	OPEN(13,FILE=outfilep)
	icnt=0
	ipcnt=0 ! keep cnt -82,...,-1
c	read(10,18,end=5,err=2) txt !extra line
c	read(10,18,end=5,err=2) txt	!extra line
C
   1	read(10,18,end=5,err=2) txt
c     ,cv3(3),rz3(3)
	yymmdd=txt(1:9)
	covi=txt(34:38)
	rzi=txt(39:41)
	if (covi(1:1).eq.' ') covi(1:1)='0'
	if (covi(2:2).eq.' ') covi(2:2)='0'
	if (rzi(1:1).eq.' ') rzi(1:1)='0'
	if (rzi(2:2).eq.' ') rzi(2:2)='0'
C	if ((yymmdd(1:4).ne.DD).and.(yymmdd(5:6).ne.cmn)) goto 1

	read(covi,*) cv3(3)
	read(rzi,*) rz3(3)
	do i=1,3
	cv3(i-1)=cv3(i)
	rz3(i-1)=rz3(i)
	enddo
	rzp(82)=rz3(3)
	cvp(82)=cv3(3)
	icnt=icnt+1
	res(icnt)=txt
	ipcnt=ipcnt+1
C Move data 1 line up:
	do k=1,82
	rzp(k-1)=rzp(k)
	cvp(k-1)=cvp(k)
	enddo
	if (ipcnt.lt.81) then
	goto 1
                       else   
	cov81=0.
	cov3=0.
	cov7=0.
	ssn81=0.
	ssn3=0.
	ssn7=0.
	do k=1,3
	ssn3=ssn3+rzp(78+k)
	cov3=cov3+cvp(78+k)
	enddo
	ssn3=ssn3/3.
	cov3=cov3/3.
      do k=1,7
	ssn7=ssn7+rzp(74+k)
	cov7=cov7+cvp(74+k)
	enddo
	cov7=cov7/7.
	ssn7=ssn7/7.
      do k=1,81
	ssn81=ssn81+rzp(k)
	cov81=cov81+cvp(k)
	enddo
	cov81=cov81/81.
	ssn81=ssn81/81.
	covp=(cov3+cov7+cov81)/3.
	ssnp=(ssn3+ssn7+ssn81)/3.
	ipcnt=ipcnt-1
c+	write(*,121) yymmdd,cvp(81),cov3,cov7,cov81,covp,rzp(81)
c+	+,ssn3,ssn7,ssn81,ssnp ! 
c+	write(13,121) yymmdd,cvp(81),cov3,cov7,cov81,covp,rzp(81)
c+	+,ssn3,ssn7,ssn81,ssnp ! 
	                   endif
	goto 1

   5	backspace(10)
	ayr=txt(2:3)
	amn=txt(5:6)
	ady=txt(8:9)
	close(unit=10)
  121	format(1X,A9,5(1X,F5.1),5(1X,F5.0))
C      
	OPEN(10,FILE=outfile)
	do jj=1,icnt-1
	write(10,18) res(jj)
	enddo

C
   20	format(2X,3A2,4X,a2,54X,F5.1)

C Read F107
	cov=70.0
	read(12,*) text
	read(12,*) text
  177	read(12,20,END=77,ERR=2) byr,bmn,bdy,aut,covx
crem	rz3(3)=rz*0.6
	if (aut.eq.'20') cov=covx
	goto 177
   77	cv3(3)=cov
crem	rz3(3)=cov*0.73-17.8
	irz=nint(rz3(3))	   
   	close(unit=12)
	irz1=nint((rz3(0)+rz3(1)+rz3(3))/3.) 
	cov1=(cv3(0)+cv3(1)+cv3(3))/3. 
C
   98	read(11,29,end=6,err=2) byr,bmn,bdy,(ikp(k),k=0,7)
	if (bmn(1:1).eq.' ') bmn(1:1)='0'
	if (bdy(1:1).eq.' ') bdy(1:1)='0'
	if ((byr.eq.ayr).and.(bmn.eq.amn).and.(bdy.eq.ady)) then
	do k=0,7
	xkp=float(ikp(k))/10.
	call subkpap(xkp,jap)
	iap(k)=jap
	enddo
	write(*,21) byr,bmn,bdy,(iap(k),k=0,7),cov,irz ! for prec. day
	write(10,21) byr,bmn,bdy,(iap(k),k=0,7),cov,irz ! for prec. day
	endif
	if ((byr.eq.cyr).and.(bmn.eq.cmn).and.(bdy.eq.cdy)) then
	do k=0,7
	xkp=float(ikp(k))/10.
	call subkpap(xkp,jap)
	iap(k)=jap
	enddo
	issnp=nint(ssnp)
	write(*,21) byr,bmn,bdy,(iap(k),k=0,7),cov1,irz1 ! for current day
	write(10,21) byr,bmn,bdy,(iap(k),k=0,7),cov1,irz1 ! for current day
c-	write(*,21) byr,bmn,bdy,(iap(k),k=0,7),covp,issnp ! for current day
c-		write(10,21) byr,bmn,bdy,(iap(k),k=0,7),covp,issnp ! for current day
	goto 99
	else
	 goto 98
	endif
    6	close(unit=11)

   18	format(A41)
c--   18	format(A33,F5.1,F3.0)
   19	format(A128)
   21	format(3(1X,A2),8(I3),F5.1,I3)
   29	format(3A2,6X,8I2)
C
   99	continue             ! mn-to-mn cycle
 	GOTO 33
C

    2 CONTINUE
c-      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
c-      endif

   33	continue
	close(unit=10)
      write(*,*) infile1,infile2,outfile
      pause ' ' 
   34   STOP
       END

C***********************************************************
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !NEW+7
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
