	program catstorj
C.....................................................Oct. 2014
C
C Use wcMMDDUT.jYR files limited by geogr.lat x Ionex=longs BELOW MLAT=-60 & above MLAT=+60 deg.
C.............................................................
C 4 substorms Catalogs of positive (W=3,4) and negative (W=-3,-4) at 2 auroral regions
C = Summary (RANGE) catalogues for (1) North and (2) South auroral regions (AE type)
C+2 Range catalogues nr, sr
C
C.....................................................May 2014
C Count occurremce of W=-4,-3,and W=3,4
C  
C
C JPL maps  in MLATxMLON format
C
C subset : mlats=-85,-80,-75,-70,-65,-60 (lines 1,2,...,6) South (432 grids)
C subset : mlats=60,65,70,75,80,85 (lines 30,31,...,35) North	   (432 grids)
c from hourly maps
c
	DIMENSION IDHR(71,0:71),IM(12)
	+,iwun(0:23)  ! values of W=+3,+4 North 
	+,iwln(0:23)  ! values of W=-3,-4 North
	+,iwus(0:23)  ! values of W=+3,+4 North
	+,iwls(0:23)  ! values of W=-3,-4 North
	+,xwun(0:23)  ! values of W=+3,+4 North %
	+,xwln(0:23)  ! values of W=-3,-4 North %
	+,xwus(0:23)  ! values of W=+3,+4 North %
	+,xwls(0:23)  ! values of W=-3,-4 North %
	+,ires(0:23),ires1(0:23),ires2(0:23)
	+,tlats(0:71) ! limits of glats@glong for South  at glongs=-180:5:175
	+,tlatn(0:71) ! limits of glats@glong for North  at glongs=-180:5:175
c	+,xres(9),xress(9),xresn(9),res(9),ress(9),resn(9)
	 INTEGER*2 IYR,IMN,IDY,idy1,idy2,iut,kyr,iyr0,imnend
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64,infile,outewun,outewln,outewus,outewls
	+,outewrn,outewrs
	CHARACTER*2 AYR,AMN,AUT,ADY
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA tlats/
	* -58.3,-59.3,-60.1,-61.1,-62.0,-62.8,-63.6,-64.4,-65.1,-65.8
     *,-66.4,-67.0,-67.6,-68.0,-68.4,-68.8,-69.1,-69.4,-69.6,-69.8
     *,-69.9,-69.9,-69.9,-69.9,-69.8,-69.6,-69.4,-69.2,-68.8,-68.5
     *,-68.1,-67.6,-67.1,-66.5,-65.9,-65.2,-64.5,-63.7,-62.9,-62.1
     *,-61.2,-60.2,-59.4,-58.4,-57.5,-56.6,-55.7,-54.9,-54.1,-53.4
     *,-52.7,-52.1,-51.5,-51.0,-50.7,-50.4,-50.2,-50.1,-50.1,-50.2
     *,-50.3,-50.6,-51.0,-51.5,-52.0,-52.6,-53.3,-54.1,-54.8,-55.7
     *,-56.5,-57.4/
	DATA tlatn/
     *  64.5, 63.7, 62.9, 62.1, 61.2, 60.2, 59.4, 58.4, 57.5, 56.6
     *, 55.7, 54.9, 54.1, 53.4, 52.7, 52.1, 51.5, 51.0, 50.7, 50.4
     *, 50.2, 50.1, 50.0, 50.0, 50.0, 50.0, 50.8, 51.0, 51.3, 52.0
     *, 52.8, 54.0, 54.3, 55.5, 56.0, 56.8, 58.3, 59.3, 60.1, 61.1
     *, 62.0, 62.8, 63.6, 64.4, 65.1, 65.8, 66.4, 67.0, 67.6, 68.0
     *, 68.4, 68.8, 69.1, 69.4, 69.6, 69.8, 69.9, 69.9, 69.9, 69.9
     *, 69.8, 69.6, 69.4, 69.2, 68.8, 68.5, 68.1, 67.6, 67.1, 66.5
     *, 65.9, 65.2/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C start
	 cntot=0.
	cntots=0.
	cntotn=0.
      outewun='wjYRun.txt'	! percent of W=+3,+4 North auroral zone
	outewln='wjYRln.txt'	! percent of W=-3,+4 North auroral zone
	outewrn='wjYRrn.txt'	! total percent of W=+3, +4, W=-3,-4 North zone
	outewus='wjYRus.txt'	! percent of W=+3,+4 South auroral zone
	outewls='wjYRls.txt'	! percent of W=-3,-4 South Arctic zone
	outewrs='wjYRrs.txt'	! total percent of W=+3, +4, W=-3,-4 South zone

c-      WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
c-      READ(*,'(A)') AYEAR
C
C start cycle on uear: =====================================
C
	iyear0=1998
	iyr0=98
C
	DO 400 kyr=1,16
crem	kyr=16         ! 2014
	iyr=iyr0+kyr
	if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,AYR)
	outewun(3:4)=AYR
	outewln(3:4)=AYR
	outewrn(3:4)=AYR
	outewus(3:4)=AYR
	outewls(3:4)=AYR
	outewrs(3:4)=AYR
  	OPEN(111,FILE=outewun,access='APPEND')
  	OPEN(112,FILE=outewln,access='APPEND')
  	OPEN(113,FILE=outewus,access='APPEND')
  	OPEN(114,FILE=outewls,access='APPEND')
	OPEN(115,FILE=outewrn,access='APPEND')
	OPEN(116,FILE=outewrs,access='APPEND')
crem	
CNO	xmap=432.
C	xmaps=0.     !South
C	xmapn=0.     !North
	year=float(iyr)
	if(int(year/4.)*4.eq.iyr) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF
	imnend=12
	if (iyr.eq.14) imnend=9     ! end month in 2014
C start cycle on month ---------------------------------
	DO 401 imn=1,imnend
	call blet2(imn,AMN)
      
 13   FORMAT(I2)
	idy1=1
	idy2=im(imn)
CC CALCULATION OF DAYS OF YEAR	
      infile='d:\web\dws\YR\MN\wcMNDYUT.jYR' ! JPL W(glat & glong map)
  	infile(12:13)=ayr
	infile(15:16)=amn
  	infile(28:29)=ayr
	infile(20:21)=amn
C
 198	format(4X,A2,24(3X,A2),3X,A4)
C
	mndy=idy2
  130	format(A133)

C
C
CC  
  197 continue
C
C  day-to-day cycle
C ========================================

       DO 500 idy=idy1,idy2
	lda=ndoy(iyr,mn,idy)  ! day-of-year
	call blet2(idy,ady)
	infile(22:23)=ady
C
	do i=0,23
	iwun(i)=0
	iwln(i)=0
	iwus(i)=0
	iwls(i)=0
	enddo
C
C cycle on UT:
C -----------------------------------------------------
      DO 801 iut=0,23		! cycle on UT
	call blet2(iut,aut)
	infile(24:25)=aut
	xmaps=0.     !South	count grids
	xmapn=0.     !North	count grids

	OPEN(110,FILE=INFILE)
c
C ===== Input datafile 
c
	DO jj=1,71
    1	READ (110,12,END=3,ERR=2) (IDHR(jj,k),k=0,71) ! W(longs=-180:5:175)
	ENDDO
  3   CLOSE(unit=110)

  12	FORMAT(72(1X,I4))
C
C subpolar areas selection:
C
	glat=-90.0
 1311	DO 1799 jj=1,71	  ! glats= -87.5:2.5:87.5
	glat=glat+2.5
C
	if ((jj.gt.16).and.(jj.lt.56)) goto 1799 ! avoid intermediate latitudes
C
       DO k=0,71				! Cycle on Longi	 <<<<<<<<
C++ Count storm indices W:
c		South:
	if ((jj.le.16).and.(glat.le.tlats(k))) then
	xmaps=xmaps+1.            ! cnt grids in S. area
	if ((idhr(jj,k).eq.-3).or.(idhr(jj,k).eq.-4)) then
	iwls(iut)=iwls(iut)+1
	endif
	if ((idhr(jj,k).eq.3).or.(idhr(jj,k).eq.4)) then
	iwus(iut)=iwus(iut)+1
	endif
	                     endif
c		North:
      if ((jj.ge.56).and.(glat.ge.tlatn(k))) then
	xmapn=xmapn+1.            ! cnt grids in N. area
	if ((idhr(jj,k).eq.-3).or.(idhr(jj,k).eq.-4)) then
	iwln(iut)=iwln(iut)+1
	endif
	if ((idhr(jj,k).eq.3).or.(idhr(jj,k).eq.4)) then
	iwun(iut)=iwun(iut)+1
	endif
	                  endif
C
	 ENDDO		    ! Cycle on Longi	 >>>>>>>>>>>>>
 1799	CONTINUE				   ! Cycle jj on glats (total W map)
	 xwun(iut)=iwun(iut)/xmapn*100.  ! values of W=+3,+4 North %
	 xwln(iut)=iwln(iut)/xmapn*100.  ! values of W=-3,-4 North %
	 xwus(iut)=iwus(iut)/xmaps*100.  ! values of W=+3,+4 North %
	 xwls(iut)=iwls(iut)/xmaps*100.  ! values of W=-3,-4 North %

C----------------------------------------------------------
  801 continue            ! end cycle on UT 

	do ii=0,23
	ires1(ii)=nint(xwun(ii)*10.) !percent*10
	enddo
c	write(*,72) AYR,AMN,ADY,(ires1(k),k=0,23)       ! 
	write(111,72) AYR,AMN,ADY,(ires1(k),k=0,23)       ! 

	do ii=0,23
	ires2(ii)=nint(xwln(ii)*10.) !percent*10
	ires(ii)=ires1(ii)+ires2(ii)
	enddo
c	write(*,72) AYR,AMN,ADY,(ires2(k),k=0,23)       ! 
	write(112,72) AYR,AMN,ADY,(ires2(k),k=0,23)       ! 
C+
	write(*,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 
	write(115,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 

	do ii=0,23
	ires1(ii)=nint(xwus(ii)*10.) !percent*10
	enddo
c	write(*,72) AYR,AMN,ADY,(ires1(k),k=0,23)       ! 
	write(113,72) AYR,AMN,ADY,(ires1(k),k=0,23)       ! 

	do ii=0,23
	ires2(ii)=nint(xwls(ii)*10.) !percent*10
	ires(ii)=ires1(ii)+ires2(ii)
	enddo
c	write(*,72) AYR,AMN,ADY,(ires2(k),k=0,23)       ! 
	write(114,72) AYR,AMN,ADY,(ires2(k),k=0,23)       ! 
C
C+
	write(*,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 
	write(116,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 

C
  500	CONTINUE ! next day
  401	CONTINUE ! next month
C
   72 format(3A2,24(1X,I4))
	close(unit=111)
	close(unit=112)
	close(unit=113)
	close(unit=114)
	close(unit=115)
	close(unit=116)
C Annual

  400	CONTINUE ! next year

	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

