	program catstorm
C 4 substorms Catalogs of positive (W=3,4) and negative (W=-3,-4) at 2 auroral regions
C
C.....................................................May 2014
C Count occurremce of W=-4,-3,and W=3,4
C  
C
C JPL maps  in MLATxMLON format
C
C subset : mlats=-85,-80,-75,-70,-65,-60 (lines 1,2,...,6) South (432 grids)
C subset : mlats=60,65,70,75,80,85 (lines 30,31,...,35) North	   (432 grids)
c from hourly maps
c
	DIMENSION IDHR(0:71),IM(12)
	+,iwun(0:23)  ! values of W=+3,+4 North 
	+,iwln(0:23)  ! values of W=-3,-4 North
	+,iwus(0:23)  ! values of W=+3,+4 North
	+,iwls(0:23)  ! values of W=-3,-4 North
	+,xwun(0:23)  ! values of W=+3,+4 North %
	+,xwln(0:23)  ! values of W=-3,-4 North %
	+,xwus(0:23)  ! values of W=+3,+4 North %
	+,xwls(0:23)  ! values of W=-3,-4 North %
	+,ires(0:23)
c	+,xres(9),xress(9),xresn(9),res(9),ress(9),resn(9)
	 INTEGER*2 IYR,IMN,IDY,idy1,idy2,iut,kyr,iyr0
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64,infile,outewun,outewln,outewus,outewls
	CHARACTER*2 AYR,AMN,AUT,ADY
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C start
	 cntot=0.
	cntots=0.
	cntotn=0.
      outewun='wmYRun.txt'	! percent of W=+3,+4 North auroral zone
	outewln='wmYRln.txt'	! percent of W=-3,+4 North auroral zone
	outewus='wmYRus.txt'	! percent of W=+3,+4 South auroral zone
	outewls='wmYRls.txt'	! percent of W=-3,-4 South Arctic zone

c-      WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
c-      READ(*,'(A)') AYEAR
C
C start cycle on uear: =====================================
C
	iyear0=1998
	iyr0=98
C
crem	DO 400 kyr=1,15
	kyr=16         ! 2014
	iyr=iyr0+kyr
	if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,AYR)
	outewun(3:4)=AYR
	outewln(3:4)=AYR
	outewus(3:4)=AYR
	outewls(3:4)=AYR
  	OPEN(111,FILE=outewun,access='APPEND')
  	OPEN(112,FILE=outewln,access='APPEND')
  	OPEN(113,FILE=outewus,access='APPEND')
  	OPEN(114,FILE=outewls,access='APPEND')
crem	
	xmap=432.
	year=float(iyr)
	if(int(year/4.)*4.eq.iyr) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF
C start cycle on month ---------------------------------
crem	DO 401 imn=1,12
crem	DO 401 imn=1,5
crem	DO 401 imn=6,6
	DO 401 imn=7,7
	call blet2(imn,AMN)
      
 13   FORMAT(I2)
	idy1=1
	idy2=im(imn)
CC CALCULATION OF DAYS OF YEAR	
      infile='d:\web\dwm\YR\MN\wmMNDYUT.jYR' ! JPL W(mlat & mlong map)
  	infile(12:13)=ayr
	infile(15:16)=amn
  	infile(28:29)=ayr
	infile(20:21)=amn
C
 198	format(4X,A2,24(3X,A2),3X,A4)
C
	mndy=idy2
  130	format(A133)

C
C
CC  
  197 continue
C
C  day-to-day cycle
C ========================================

       DO 500 idy=idy1,idy2
	lda=ndoy(iyr,mn,idy)  ! day-of-year
	call blet2(idy,ady)
	infile(22:23)=ady
C
	do i=0,23
	iwun(i)=0
	iwln(i)=0
	iwus(i)=0
	iwls(i)=0
	enddo
C
C cycle on UT:
C -----------------------------------------------------
      DO 801 iut=0,23		! cycle on UT
	call blet2(iut,aut)
	infile(24:25)=aut
	OPEN(110,FILE=INFILE)
c
C ===== Input datafile 
 1311	DO 1799 jj=1,35	  ! mlats= -85:5:85
c	pause ' '
    1	READ (110,12,END=3,ERR=2) (IDHR(k),k=0,71) ! W(longs=-180:5:175)
  12	FORMAT(72(1X,I4))
C
	if ((jj.ge.7).and.(jj.le.29)) goto 1799 ! avoid intermediate latitudes
C
       DO k=0,71				! Cycle on Longi	 <<<<<<<<
C++ Count storm indices W:
c		South:
	                  if (jj.lt.7) then
	if ((idhr(k).eq.-3).or.(idhr(k).eq.-4)) then
	iwls(iut)=iwls(iut)+1
	endif
	if ((idhr(k).eq.3).or.(idhr(k).eq.4)) then
	iwus(iut)=iwus(iut)+1
	endif
	                     endif
c		North:
	                  if (jj.gt.29) then
	if ((idhr(k).eq.-3).or.(idhr(k).eq.-4)) then
	iwln(iut)=iwln(iut)+1
	endif
	if ((idhr(k).eq.3).or.(idhr(k).eq.4)) then
	iwun(iut)=iwun(iut)+1
	endif
	                  endif
C
	 ENDDO		    ! Cycle on Longi	 >>>>>>>>>>>>>
 1799	CONTINUE				   ! Cycle jj on glats (total W map)
  3   CLOSE(unit=110)
	 xwun(iut)=iwun(iut)/xmap*100.  ! values of W=+3,+4 North %
	 xwln(iut)=iwln(iut)/xmap*100.  ! values of W=-3,-4 North %
	 xwus(iut)=iwus(iut)/xmap*100.  ! values of W=+3,+4 North %
	 xwls(iut)=iwls(iut)/xmap*100.  ! values of W=-3,-4 North %

C----------------------------------------------------------
  801 continue            ! end cycle on UT 

	do ii=0,23
	ires(ii)=nint(xwun(ii)*10.) !percent*10
	enddo
	write(*,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 
	write(111,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 

	do ii=0,23
	ires(ii)=nint(xwln(ii)*10.) !percent*10
	enddo
	write(*,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 
	write(112,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 

	do ii=0,23
	ires(ii)=nint(xwus(ii)*10.) !percent*10
	enddo
	write(*,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 
	write(113,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 

	do ii=0,23
	ires(ii)=nint(xwls(ii)*10.) !percent*10
	enddo
	write(*,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 
	write(114,72) AYR,AMN,ADY,(ires(k),k=0,23)       ! 
C

C
  500	CONTINUE ! next day
  401	CONTINUE ! next month
C
   72 format(3A2,24(1X,I4))
	close(unit=111)
	close(unit=112)
	close(unit=113)
	close(unit=114)
C Annual

  400	CONTINUE ! next year

	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

