	program cntstormn
C T.L. Gulyaeva                                                        
C........................................................................June 2014
C Count monthly hrs of sub-storms from 4 Catalogues
C
C pW>=10% = storm onset, storm end. Power p=Wpmax*Tdur>=200.
C
	CHARACTER*35 INFILE
	CHARACTER*24 OUTFILE
	CHARACTER*2 AYR,DYR
	INTEGER ioc(12)
	integer irun
C
	infile='catwxx.txt'
C
C Cycle on 4 Catalogs:
C
	DO 180 icase=1,4
	irun=0
	if (icase.eq.1) INFILE(5:6)='un'   !'wmYRun.txt'
	if (icase.eq.2) INFILE(5:6)='ln'   !'wmYRln.txt'
	if (icase.eq.3) INFILE(5:6)='us'   !'wmYRus.txt'
	if (icase.eq.4) INFILE(5:6)='ls'   !'wmYRls.txt'
	OUTFILE=infile
	outfile(8:10)='hrs'
		OPEN(112,FILE=OUTFILE,ACCESS='APPEND')	

c	
C start cycle on year: =====================================
C
	iyear0=1998
	iyr0=98

C
	DO 400 kyr=1,15
	iyr=iyr0+kyr
	if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,AYR)
 	year=float(iyr)
 	if(int(year/4.)*4.eq.iyr) THEN 
	ndnr=366
	                          ELSE
	ndnr=365
	ENDIF
	icnt=0 ! Annual cnt

 100	continue
C Monthly count of hrs:
	do k=1,12
	ioc(k)=0
	enddo
c
	iflag=0
	OPEN(111,FILE=INFILE)

   15	READ (111,12,END=13,ERR=99) DYR,imn,ihrs
	if (DYR.ne.AYR) goto 15
   12  FORMAT (1X,A2,I2,35X,I4)
	goto 11
   13	iflag=1
   11 ioc(imn)=ioc(imn)+ihrs
	icnt=icnt+ihrs
C
	if (iflag.eq.0) then 
	goto 15
	else 
	goto 2
	endif 

C
   2   CONTINUE
       CLOSE (UNIT=111)
C
C
C
      write(*,74) ayr,(ioc(k),k=1,12),icnt
 	write(112,74) ayr,(ioc(k),k=1,12),icnt
 400  continue
C
C
  74	FORMAT(1X,A2,12(1X,I4),1X,I6)

C	PAUSE ' '
  810 CONTINUE		 ! ===================
C
      CLOSE (UNIT=112)
 180	CONTINUE
C
c      YEAR=YEAR+1
c      IF (YEAR.LT.2014) GOTO 100
   99	CONTINUE
	pause ' '
      STOP
	END
C******************************************************************************
