	program cntwjlat1d
C
C
C Monthly-lats counts FOR non-storm CONDITIONS (excluding Wp storms)
C
C separate results for 3 seasons:
C (1) equinox: mn=3,4,9,10
C (2) winter North+summer South : mn=11,12,01,01 
C (3) summer North+winter South : mn=5,6,7,8
C then re-arrange (2) and (3) results for winter and summer seasons!!!
C
C.....................................................Mar. 2014
C exclude periods of Wp storms => summary results for 1999:2013
C
C.....................................................Mar. 2014
C Cnt W+=3,4 and W-=-3,-4 events by lats 10 zones 1999-2013 
C 1 =<-80, 2 (-80:-60], 3 (-60 -40], 4 (-40 -20] 5 (-20 0) 6 (0 20] 7 (20 40] 8 [40 60) 9 = [60 80] 10>=80        
C 15 yrs counts for glongs=0:5:360, glats=-100:20:100
C Separate counts for 1h long.zones (j=1,...,24): j=1~lon_35:36:37=[-5,0,5], j=2~[10:15:20] ,..., 
C Special glong zone j=24 [+175;-180 -175]
C zone 1 glats -87.5,-85.0,-82.5 -80.0 (cnt=12)
C zone 2 glats -77.5,-75.0 -72.5 -70.0 -67.5 -65.0 -62.5 -60.0  (cnt=24) 
C zone 3 glats -57.5,-55.0 -52.5 -50.0 -47.5 -45.0 -42.5 -40.0  (cnt=24)
C zone 4 glats -37.5,-35.0 -32.5 -30.0 -27.5 -25.0 -22.5 -20.0  (cnt=24)
C zone 5 glats -17.5,-15.0 -12.5 -10.0  -7.5  -5.0  -2.5   (cnt=21)
C zone 6 glats   0.0   2.5,  5.0   7.5  10.0  12.5  15.0  17.5  (cnt=24)
C zone 7 glats  20.0  22.5, 25.0  27.5  30.0  32.5  35.0  37.5  (cnt=24)
C zone 8 glats  40.0  42.5, 45.0  47.5  50.0  52.5  55.0  57.5  (cnt=24)
C zone 9 glats  60.0  62.5, 65.0  67.5  70.0  72.5  75.0  77.5  (cnt=24)
C zone10 glats  80.0  82.5, 85.0  87.5  (cnt=12)

	DIMENSION IM(12),iocp(24,10),iocn(24,10),ith(0:10) !Occurrence annual,Total
	+,iwc(0:72) ! lon=-180:5:180, 
	+,iiw(71,0:71) ! lon=-5:5:355,lat=-87.5:2.5:87.5 
	+,iocan(24,10),ires(12)
	+,iowcnt(24,10),iopcnt(24,10),ioncnt(24,10)
	+,iwpstr(6,269)                         !Start:iyrs,ldas,iuts;End:iyre,ldae,iute
	+,imnlatp(12,10),imnlatn(12,10),icmnlat(12,10) ! mn x lat (aver for all longs)
	 INTEGER*2 IYR,imn,idy,iut,nndy
	+,iyrs,imns,idys,iuts,iyre,imne,idye,iute
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*128,infile,outfilen,outfilep,infilest
	CHARACTER*2 AYR,AMN,ADY,AUT
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA ITH/0,4,12,20,28,35,43,51,59,67,71/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
  197	format(1X,3I2,1X,I2,20X,3I2,1X,I2,1X,I4)
	infilest='wpstorms.txt'
	OPEN(15,FILE=infilest,action='READ')
	iutcn=0
	do i=1,269
	read(15,197,end=17) iyrs,imns,idys,iuts,iyre,imne,idye,iute,iutot
	iutcn=iutcn+iutot
	ldas=ndoy(iyrs,imns,idys)
	ldae=ndoy(iyre,imne,idye)
	if (iyrs.gt.98) then
	iwpstr(1,i)=iyrs+1900
	else
	iwpstr(1,i)=iyrs+2000
	endif
	iwpstr(2,i)=ldas
	iwpstr(3,i)=iuts
	if (iyre.gt.98) then
	iwpstr(4,i)=iyre+1900
	else
	iwpstr(4,i)=iyre+2000
	endif
	iwpstr(5,i)=ldae
	iwpstr(6,i)=iute
	enddo
   17	close(unit=15)
	write(*,*) iutcn
C start
      outfilep='woclat1dqp.txt'	! only Wp non-storms periods
	outfilen='woclat1dqn.txt'	! 
  	OPEN(11,FILE=OUTFILEP,access='APPEND')
	OPEN(12,FILE=OUTFILEN,access='APPEND')
c-	infile='d:\apkp\equak\M5\eq1964MN.txt'
	infile='d:\web\dws\YY\MN\wcmndyut.jyr'
C
crem	write(*,*) ' Quiet: Wp no storms mn=1:12 ' ! 
crem	write(11,*) ' Quiet: Wp no storms mn=1:12 ' ! 
crem	write(12,*) ' Quiet: Wp no storms mn=1:12 ' ! 

crem	write(*,*) ' Wp no storms Equinox mn=3,4,9,10 ' ! equinox
crem	write(11,*) ' Wp no storms Equinox mn=3,4,9,10 '	! equinox
crem	write(12,*) ' Wp no storms Equinox mn=3,4,9,10 '	! equinox
crem	write(*,*) ' Wp no storms mn=1,2,11,12 ' ! 
crem	write(11,*) ' Wp no storms mn=1,2,11,12 ' ! 
crem	write(12,*) ' Wp no storms mn=1,2,11,12 ' ! 
crem	write(*,*) ' Wp no storms mn=5,6,7,8 ' ! 
crem	write(11,*) ' Wp no storms mn=5,6,7,8 ' ! 
crem	write(12,*) ' Wp no storms mn=5,6,7,8 ' ! 

C start cycle on glongs:
	glon1=-185.
   11	glon2=glon1+5.
C		 Tptal counts for 15 years
	do i=1,10
	do j=1,12
	imnlatp(j,i)=0		   ! W+
	imnlatn(j,i)=0		   ! W-
	icmnlat(j,i)=0 
	enddo
	do k=1,24
	iowcnt(k,i)=0
      iopcnt(k,i)=0
	ioncnt(k,i)=0
	enddo
	enddo
C
	iyear0=1999
	iyr0=98
	cntot=0.
C start cycle on year: =====================================
C
	DO 500 imn=1,12
C++++++++++ for equinox
crem	if (imn.lt.3) goto 500 !for equinox
crem	if ((imn.gt.4).and.(imn.lt.9)) goto 500 !for equinox
crem	if (imn.gt.10) goto 500 !for equinox

crem	if (imn.gt.2) then
crem	 if (imn.lt.11) goto 500 !for mn=1,2,11,12
crem	endif

crem	if ((imn.lt.5).or.(imn.gt.8)) goto 500 !for mn=5,6,7,8

	write(*,*) 'non-storm mn=',imn
c-	write(11,*) 'non-storm mn=',imn
c-	write(12,*) 'non-storm mn=',imn

      call blet2(imn,AMN)
	infile(15:16)=AMN
	infile(20:21)=AMN
	nndy=im(imn)

	do k=1,24
	do i=1,10
	iocp(k,i)=0
	iocn(k,i)=0
	iocan(k,i)=0 ! total number of w during Wp storms
	enddo
	enddo

	DO 400 kyr=1,15
	iyr=iyr0+kyr
	iyyyy=iyr0+kyr
	if (iyr.ge.100) then
	iyr=iyr-100
c-	infile(20:21)='20'
	iyyyy=2000+iyr
	else
c-	infile(20:21)='19'
	iyyyy=1900+iyr
	endif
	call blet2(iyr,AYR)
	infile(12:13)=AYR
	infile(28:29)=AYR

C
	year=float(iyr)
	if(int(year/4.)*4.eq.iyr) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF
C
	cnt=0.
C
	do 221 idy=1,nndy
	call blet2(idy,ady)
	infile(22:23)=ADY
	lda=ndoy(iyr,imn,idy)
C
	do 121 iut=0,23
	call blet2(iut,AUT)
	infile(24:25)=AUT
C check if W-map refers to Wp storm
	jflag=1 ! make analysis	   ! non-storm
crem	jflag=0 ! make analysis	   ! storm
C
	do 120 js=1,269
	if (iyyyy.ne.iwpstr(1,js)) goto 120
crem	IF ((lda.lt.iwpstr(2,js)).or.(lda.gt.iwpstr(5,js))) goto 120  !storm
	IF ((lda.ge.iwpstr(2,js)).and.(lda.le.iwpstr(5,js))) THEN ! Wp storm days !non-storm

      	if ((lda.eq.iwpstr(2,js)).and.(iut.ge.iwpstr(3,js))) then    
	    jflag=0											 !non-storm
crem	    jflag=1											  !storm
	    goto 119
 	    endif
	         if ((lda.eq.iwpstr(5,js)).and.(iut.le.iwpstr(6,js))) then
	         jflag=0									   ! non-storm
crem	         jflag=1                                       !storm
              goto 119
 	         endif
	IF ((lda.gt.iwpstr(2,js)).and.(lda.lt.iwpstr(5,js))) THEN
	         jflag=0									   ! non-storm
crem	         jflag=1                                       !storm
	goto 119
	endif

	ENDIF										! NON-storm
  120	continue
C
  119	if (jflag.eq.0) goto 121 ! avoud including w=3, 4 and W = -3, -4

      OPEN(111,FILE=INFILE)

C start reading---------------------------------
C
 198	format(47X,F5.2)
C
  130	format(73(1X,I4))
C
c
C ===== Input data
C
   1  CONTINUE
	do lat=1,71
      READ (111,130,END=3,ERR=2) (iwc(k),k=0,72) ! data lines
	do jj=0,70
C
	if (jj.le.35) then
	iiw(lat,jj)=iwc(jj+35)
	else
C 
	iiw(lat,jj+1)=iwc(jj-36)
	endif
	enddo
	iiw(lat,36)=iwc(71)
	enddo
C
    3	close(unit=111)
C
	klat=1
	lat2=0
    7	lat1=lat2+1
	lat2=ith(klat)
	DO lat=lat1,lat2
    	DO lon=1,24
	k1=(lon-1)*3
	k2=k1+1
	k3=k2+1
	iw1=iiw(lat,k1)
	iw2=iiw(lat,k2)
	iw3=iiw(lat,k3)
c	do kt=1,10
c	if ((lat.gt.ith(kt-1)).and.(lat.le.ith(kt))) then
	 iocan(lon,klat)=iocan(lon,klat)+3 ! total count of grids
	if(iw1.le.-3) iocn(lon,klat)=iocn(lon,klat)+1
	if(iw2.le.-3) iocn(lon,klat)=iocn(lon,klat)+1
	if(iw3.le.-3) iocn(lon,klat)=iocn(lon,klat)+1
	if(iw1.ge.3) iocp(lon,klat)=iocp(lon,klat)+1
      if(iw2.ge.3) iocp(lon,klat)=iocp(lon,klat)+1
	if(iw3.ge.3) iocp(lon,klat)=iocp(lon,klat)+1
c	endif
c	enddo
	ENDDO			! lon
	ENDDO			! lat
		klat=klat+1
 	if (klat.le.10) goto 7

   8	continue
  121	continue       ! UT
  221	continue		! days
C
  400	CONTINUE ! next year

C
 222	format(12(1X,I5))
 223	format(1X,I4,1X,A2)

C
	do j1=1,10
	do kk=1,24
	imnlatp(imn,j1)=imnlatp(imn,j1)+iocp(kk,j1)		   ! W+
     	imnlatn(imn,j1)=imnlatn(imn,j1)+iocn(kk,j1)		   ! W-
	icmnlat(imn,j1)=icmnlat(imn,j1)+iocan(kk,j1)
	enddo
	enddo

  500	continue ! next month
  224	format(12(1X,I8))
	write(*,*) ' 1999:2013 Wp non-storms, mn=1:12'
	write(11,*) ' 1999:2013 Wp non-storms mn=1:12'
	write(12,*) ' 1999:2013 Wp non=storms mn=1:12'
crem    	write(*,*) ' 1999:2013 Wp storms, mn=1:12'
crem 	write(11,*) ' 1999:2013 Wp storms mn=1:12'
crem	write(12,*) ' 1999:2013 Wp storms mn=1:12'


crem	write(11,223) iyyyy
crem	write(12,223) iyyyy
c- 	do j1=1,10
c-	do kk=1,24
c-	iowcnt(kk,j1)=iowcnt(kk,j1)+iocan(kk,j1)
c-      iopcnt(kk,j1)=iopcnt(kk,j1)+iocp(kk,j1)
c-	ioncnt(kk,j1)=ioncnt(kk,j1)+iocn(kk,j1)

C
	do j1=1,10
c 	write(*,222) (icmnlat(k,j1),k=1,12)
c 	write(11,222) (icmnlat(k,j1),k=1,12)
c 	write(12,222) (icmnlat(k,j1),k=1,12)
	do kk=1,12
	xx=float(icmnlat(kk,j1))
	res=0.
	if (xx.gt.0.) res=float(imnlatp(kk,j1))/xx*10000. ! OC%*100
	ires(kk)=nint(res)
	enddo
 	write(*,222) (ires(k),k=1,12)
	write(11,222) (ires(k),k=1,12)
	enddo
 	do j1=1,10
	do kk=1,12
	xx=float(icmnlat(kk,j1))
	res=0.
	if (xx.gt.0.) res=float(imnlatn(kk,j1))/xx*10000. ! OC%*100
	ires(kk)=nint(res)
	enddo
 	write(*,222) (ires(k),k=1,12)
	write(12,222) (ires(k),k=1,12)
	enddo

C
C
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      CLOSE (UNIT=11)
      CLOSE (UNIT=12)
      STOP
      END

