	program histwwyr
c .......................................................Nov. 2014
C Histogram of 3hourly-max percentage storm W-, W+,% occurrence from annual results wwYRxx.txt
C for 1999-2013 
C if 3h max =0 then exclude this interval from total count of intervals 
C
c input annual files collected for UT: 0, 1, ...,23 hrs
c from jhrg TEC maps
c
	DIMENSION iwp(0:23),ITHR(10),icnt(10),iper(10)
	+,im(12),iwp3(8)
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64,infile,outfile
	CHARACTER*2 AYR,xx
	CHARACTER*128 txt
	CHARACTER*6 YRMNDY
	integer*2 iyr,imn,jyr
	DATA ITHR/0,100,200,300,400,500,600,700,800,900/ 
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
	icntot=0 ! count of 3h intervals for 15 years
		  outfile='histwwyr.res'
	OPEN(112,FILE=OUTFILE,ACCESS='APPEND')
C start
	do i=1,10
	icnt(i)=0	  ! Hist
	enddo
	write(*,*) 'Enter xx=un,ln,us,ls,ug,lg for title wwYRxx.txt ' 
	read(*,73) xx
   73 format(A2)
CREM		 infile='wwYRxx.txt'
		 infile='wjYRxx.txt'
	infile(5:6)=xx
	write(*,74) infile
	write(112,74) infile
   74 format(1X,A10)
C cycle on year	
	jyr=0
  103	jyr=jyr+1
	if (jyr.gt.15) goto 105
c	DO 101 jyr=1,1,15
	iyr=jyr+98
	if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,AYR)
  	infile(3:4)=ayr
	OPEN(111,FILE=INFILE)
	read(111,71) txt           ! extra line
   71 format(A128)
CC CALCULATION OF DAYS OF YEAR	
C
	year=float(iyr)
	if(int(year/4.)*4.eq.iyr) THEN 
	ndnr=366
	im(2)=29
	                          ELSE
	ndnr=365
	im(2)=28
	ENDIF

C cycle on month:
	DO 102 imn=1,12

	ndnr=im(imn)
c     
C ===== Input datafile 
 1311	DO 1799 jj=1,ndnr
c
    1	READ (111,12,END=55,ERR=2) YRMNDY,(iwp(k),k=0,23)
  12	FORMAT(A6,24(1X,I4))
C Select maxWp for 3 hrs
	kk=0
	DO k=0,23,3
	kk=kk+1
	iwmax=0.
	if (iwp(k).gt.iwmax) iwmax=iwp(k)
	if (iwp(k+1).gt.iwmax) iwmax=iwp(k+1)
	if (iwp(k+2).gt.iwmax) iwmax=iwp(k+2)
	iwp3(kk)=iwmax
	if (iwmax.gt.0) icntot=icntot+1 
	ENDDO
C
crem	icntot=icntot+8
C
	do 1234 k=1,8
	if (iwp3(k).eq.0) goto 1234
	if (iwp3(k).ge.ithr(10)) then
	icnt(10)=icnt(10)+1
	goto 1234
	endif
	do j=1,9
	if ((iwp3(k).ge.ithr(j)).and.(iwp3(k).lt.ithr(j+1))) then
	icnt(j)=icnt(j)+1
	goto 1234
 	endif
	enddo
1234	CONTINUE	   
 1799	CONTINUE
102   continue
  55  CLOSE(unit=111)

101   continue		 ! cycle on jyr
	goto 103
C  %
105	do k=1,10
	per=float(icnt(k))/float(icntot)*100.
	iper(k)=nint(per*10000)
	enddo
	write(*,72) (iper(k),k=1,10),icntot
	write(112,72) (iper(k),k=1,10),icntot
c   

  800 CONTINUE             


   72 format(1X,10(1X,I8),3X,I8)
   75 continue	 

	CLOSE(unit=112)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

