	program exdstw30
C ------------------------------------------------------------Apr 2009
C Extract Dst-period( + Wpk, +AE) for Dst-STORMS 
C Select -5h before Dstmin,+Dstmin, +24 hrs sfter DSTmin
C ++++++++++++  Produce AVERAGE and/OR STD +++++++++++++++++++++
C
C for Dst-strm : 6 hrs before storm+24 hrs since storm onset
C This version to detect TEC storm effects using input Dst-data !!!
C T.L. Gulyaeva                                            
      DIMENSION IM(12)
	DIMENSION YDEV(0:23),IUT(0:23)
	+,dst(30),wkp(30),aei(30),sdst(30),swkp(30),saei(30)
	+,XR(366,0:23),WP(366,0:23),AE(366,0:23)
	+,dsav(30),wpav(30),aeav(30)
	CHARACTER*22 INFILE1,infile2,infile3
	CHARACTER*20 title
	CHARACTER*25 OUTFILE
c	CHARACTER*6 yymmdd,power
	CHARACTER*4	DA(366,0:23)
c	+,JXR(366,0:23),JWP(366,0:23),JAE(366,0:23)
	CHARACTER*68 wpt(300),adst
c	CHARACTER*120 txt

	CHARACTER*72 XXX
	CHARACTER*4	SYEAR,AHRS,DSTMAX

	CHARACTER*2 AYR,AMN,ADY,AUT,AYR2,AMN2,ADY2,AUT2
c	+,JD3(366,3)
	REAL YEAR
	COMMON DA
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA DSAV/-41.6,-48.5,-57.1,-68.2,-82.0,-92.5,-83.5,-75.8,-71.3
	+,-68.3,-65.7,-62.0,-59.3,-58.0,-56.1,-54.3,-52.7,-51.3,-50.2,
     +-49.1,-47.4,-46.0,-44.4,-43.6,-42.7,-41.4,-40.7,-40.7,-40.1,-39.3/
	DATA WPAV/4.4,4.6,4.8,4.9,5.1,5.3,5.3,5.3,5.3,5.2,5.1,5.0,5.0,4.9
	+,4.8,4.8,4.8,4.7,4.8,4.8,4.7,4.7,4.6,4.6,4.5,4.4,4.4,4.4,4.4,4.3/
	DATA AEAV/626.1,645.6,647.0,726.5,776.1,688.2,566.4,496.3,432.7
	+,393.2,386.9,392.9,373.3,372.7,370.0,350.6,330.6,335.2,336.7
	+,323.0,309.2,312.8,321.8,310.6,287.5,288.9,290.6,288.8,281.1,281.5
     +/

C
	irun=0
	do i=0,23
	iut(i)=i
	enddo
c	event='+dst+wpk'
	cnt30=0.
	do j=1,30
	dst(j)=0.
	wkp(j)=0.
	aei(j)=0.
	enddo
C
Temp	OPEN(110,file='wptstrm.txt')
      OPEN(110,file='dststrm2.txt')
	read(110,111) xxx	   ! extra line
	write(*,111) xxx
  111	format(A64)
C
	iflag=0
      js=0
	DO 100 j=1,755
		read(110,9,err=8,end=7) wpt(j) ! Dst<=-50 events
	write (*,9) wpt(j)
   9  FORMAT(1X,A68)
	js=js+1
 100	continue
	goto 7
   8	write(*,*) 'Error in Dst file'
	pause ' '
	stop
   7	close(unit=110)
c      WRITE(*,'(A\)') ' ENTER YEAR    :'
C Cycle on storms:
c-	INFILE1='rwip98.ind'
	INFILE1='dst1999'
	INFILE2='wptkYR.txt'
	INFILE3='AE1999'
	outfile='aedstw30.txt'
			OPEN(114,FILE=OUTFILE,ACCESS='APPEND')	
	istart=0
C   Cycle on Dst-storms:
	DO 900 IST=1,js

	ADST=wpt(IST)
v	AYR=ADST(4:5)
	AYR=ADST(19:20)	   ! Dstmin
v	AMN=ADST(6:7)	   
	AMN=ADST(21:22)	   ! Dstmin
v	ADY=ADST(9:10)
	ADY=ADST(24:25)	   ! Dstmin
c	if ((AYR.eq.cyr).and.(amn.eq.cmn).and.(ady.eq.cdy)) then

v	AUT=ADST(12:13)
	AUT=ADST(44:45)	   ! Dstmin
	IF (AUT(1:1).eq.' ') AUT(1:1)='0'

	DSTMAX=ADST(37:40)
	IF (DSTMAX(1:1).eq.' ') DSTMAX=ADST(38:41)
	read(DSTMAX,*) dstmin   ! real DSTmin
C
cc	if (dstmin.gt.-100.) goto 900      ! Select moderate Dst events
	irun=irun+1
		write(114,10) adst,irun
   10	format(1X,A68,2X,I4)
C
	AYR2=ADST(51:52)
	AMN2=ADST(53:54)
	ADY2=ADST(56:57)
	AUT2=ADST(59:60)
	IF (AUT2(1:1).eq.' ') AUT2(1:1)='0'
c	AHRS=ADST(51:53)
c	power=ADST(62:67)
			READ (AYR,*) AAYR
	iyr=int(aayr)
			READ (AMN,*) AAMN
				imn=int(aamn)
		READ (ADY,*) AADY
			idy=int(AADY)
	READ (AUT,*) AAUT
			iut1=int(AAUT)
			READ (AYR2,*) AAAYR
	iyr2=int(aaayr)
 			READ (AMN2,*) AAAMN
				imn2=int(aaamn)
		READ (ADY2,*) AAADY
			idy2=int(aaaDY)
	READ (AUT2,*) AAAUT
			iut2=int(AAAUT)
C      READ (*,*) SYEAR
	if (ayr.eq.'99') then
	syear='1999'
	                 else
	syear='2000'
	syear(3:4)=ayr
	endif
	READ (SYEAR,*) YEAR
	YEAR1=YEAR
c
      IF ((YEAR/4.).EQ.IFIX(YEAR/4.)) THEN 
	IM(2)=29 
	IDNR=366
	ELSE 
	IM(2)=28
	IDNR=365
	ENDIF

CC CALCULATION OF DAY OF YEAR	(LDA)
	      mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234   mosum=mosum+im(i)
         endif
      lda1=mosum+idy          ! daynr

C Dst-storm peak -5 hrs
	lda0=lda1
	ldak=lda1

	iut0=iut1-5
	iutk=iut1+24

	idy0=idy
	idyk=idy

	imn0=imn
	imnk=imn

	if (iut0.lt.0) then
	iut0=iut0+24
	idy0=idy-1
	lda0=lda1-1
	if (idy0.lt.1) then
	 imn0=imn-1
	idy0=im(imn0)
	endif
	              endif
	
      if (iutk.ge.24) then
	iutk=iutk-24
	idyk=idyk+1
	ldak=lda1+1
	if (ldak.gt.366) then
c	 imn0=imn-1
	idak=366
	endif
	              endif
	
	      mosum=0
      if(imn2.gt.1) then
         do 1235 i=1,imn2-1
1235   mosum=mosum+im(i)
         endif
      lda2=mosum+idy2          ! daynr
	if (iflag.eq.0) goto 117
	if (infile1(4:7).eq.SYEAR) then
	 goto 178	 ! Avoid reading data file
	else
	 iflag=0
	endif
	
  117	iflag=1
      INFILE1(4:7)=SYEAR
	INFILE2(5:6)=AYR
	INFILE3(3:6)=SYEAR
		OPEN(111,FILE=INFILE1)
	OPEN(112,FILE=INFILE2)
	OPEN(113,FILE=INFILE3)
C
c    5	format(1X,A55,A17)
C Start day-to-day cycle:
c	write(114,10) (iut(k),k=0,23)
	DO 151 J=1,IDNR
	READ (111,12,END=120,ERR=99) TITLE,YDEV ! read Dst
   12  FORMAT (A20,24(F4.0),4x)
	do k=0,23
	xr(j,k)=ydev(k)
	enddo
  151	continue
  120	close(unit=111)
C
	DO 152 J=1,IDNR
	READ (113,12,END=121,ERR=99) TITLE,YDEV ! read AE
	do k=0,23
	ae(j,k)=ydev(k)
	enddo
  152	continue
  121	close(unit=113)
	DO 153 J=1,IDNR
	READ (112,102,END=122,ERR=99) TITLE,YDEV ! read Wpk
  102  FORMAT (A6,24(1X,F4.1),6x)
	do k=0,23
	wp(j,k)=ydev(k)
	enddo
  153	continue
  122	close(unit=112)
C
 178	sumr=0.
	i30=0
	cnt30=cnt30+1.
  154	DO 15 J=LDA0,LDAK
	if (j.eq.lda0) then
	do m=iut0,23
	i30=i30+1
	dst(i30)=xr(j,m)
	wkp(i30)=wp(j,m)
	aei(i30)=ae(j,m)
Av	sdst(i30)=sdst(i30)+dst(i30)   !av
Av	swkp(i30)=swkp(i30)+wkp(i30)   !av
Av	saei(i30)=saei(i30)+aei(i30)   !av
	sdst(i30)=sdst(i30)+(dst(i30)-dsav(i30))**2   !std
	swkp(i30)=swkp(i30)+(wkp(i30)-wpav(i30))**2   !std
	saei(i30)=saei(i30)+(aei(i30)-aeav(i30))**2   !std
	enddo
	goto 15
	endif
	if ((ldak-j).eq.0) then
	iutt=iutk
	else
	iutt=23
	endif
		do m=0,iutt
	i30=i30+1
	dst(i30)=xr(j,m)
	wkp(i30)=wp(j,m)
	aei(i30)=ae(j,m)
Av	sdst(i30)=sdst(i30)+dst(i30)   !av
Av	swkp(i30)=swkp(i30)+wkp(i30)   !av
Av	saei(i30)=saei(i30)+aei(i30)   !av
	sdst(i30)=sdst(i30)+(dst(i30)-dsav(i30))**2   !std
	swkp(i30)=swkp(i30)+(wkp(i30)-wpav(i30))**2   !std
	saei(i30)=saei(i30)+(aei(i30)-aeav(i30))**2   !std
	enddo
  15 	continue
C
C Output IUT, Wpk,DST,AE for day1 to day2:
C
	 do m=1,30
d 	if ((iut(m).eq.iut2).or.(iut(m).eq.iut2-1)) then
d		jjut2=m
d	 exit
d	endif
Temp	write(*,125) m,wkp(m),dst(m),aei(m)
Temp	write(114,125) m,wkp(m),dst(m),aei(m)
	 enddo
Av  125	format(1X,I2,3(1X,F6.1)) !av
  125	format(1X,I2,3(1X,F7.2))	 !std

  900	continue            !!! Stormd cycle
Av	write(*,*) ' ******** Average ********* count=',cnt30 !av
Av	write(114,*) ' ******** Average ********* count=',cnt30	 !av
	write(*,*) ' ******** STD ********* count=',cnt30 !std
 	write(114,*) ' ******** STD ********* count=',cnt30	 !std

	do m=1,30
Av	dst(m)=sdst(m)/cnt30  !av
Av 	wkp(m)=swkp(m)/cnt30  !av
Av	aei(m)=saei(m)/cnt30  !av
	dst(m)=sqrt(sdst(m)/cnt30)  !std
 	wkp(m)=sqrt(swkp(m)/cnt30)  !std
	aei(m)=sqrt(saei(m)/cnt30)  !std

	write(*,125) m,wkp(m),dst(m),aei(m)
	write(114,125) m,wkp(m),dst(m),aei(m)
	 enddo

C
C  710 CONTINUE
	goto 99
    2   CONTINUE
	write(*,*) 'Error reading data'
   99	CONTINUE
	CLOSE (UNIT=114)
	pause ' '
      STOP
	END
C******************************************************************************
