      program extraverj
C..................................................................Mar. 2014
C for JPL data
C rms between two maps for 24 h UT
C
C fht='f', 'h', 't' for foF2, hmF2, TEC
C iyr,imn,idy -last available date-of-maps
	DIMENSION XMAP1(0:72,71),XMAP2(0:72,71) !GLON,GLAT
	+,IM(12),rx(0:72)
	CHARACTER*1 fht
	CHARACTER*48 INFILE1,INFILE2,OUTFILE  
		integer*2 IYR,IMN,IDY,IUT
	+,IDY1,kdy  ! 
	CHARACTER*2 AYR,AUT,AMN,ADY
            DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
crem	fht='t'          ! temp TEC maps
	fht='w'          ! temp TEC maps
	outfile='extaverj.txt'
	OPEN(110, file=outfile,access='APPEND')
	do k=0,72
	do n=1,71
	XMAP1(k,n)=0.
	XMAP2(k,n)=0.
	enddo
	enddo
	WRITE(*,*)' ENTER YR OF INPUT FILE=	'
ctemp	read(*,17) AYR
	AYR='14'
   17 format (A2)
  107	FORMAT(73(1X,F4.0))	
	write(*,17) ' YR=',ayr
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
C
	WRITE(*,*)' ENTER CURRENT MN'
	READ(*,13) IMN
crem	imn=02
   13 FORMAT(I2)
	call blet2(imn,amn)  ! current month
		write(*,*) AMN
C
 	WRITE(*,*)' ENTER IDY1'
 	READ(*,13) IDY1
 255	idy2=idy1


200   continue	  
 	if (iyr.lt.90) then
 	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
 	call blet2(iyr,ayr)  ! current year
 	call blet2(imn,amn)  ! current month
 	call blet2(idy,ady)  ! current day
C month:
  	 infile1='d:\web\dts\YY\MM\tcMMDDUT.jYY'   ! 
	infile1(9:9)=fht
	infile1(18:18)=fht
 	infile1(12:13)=ayr
	infile1(15:16)=amn
 	infile1(20:21)=amn
	infile1(28:29)=ayr
	 
	infile2='d:\web\graf\dtc\YY\MM\ut\tcMMDDUT.jYY'   ! 
	infile2(14:14)=fht
	infile2(26:26)=fht
 	infile2(17:18)=ayr
	infile2(20:21)=amn
 	infile2(28:29)=amn
	infile2(36:37)=ayr
C
C =======================================================
C
C Reading current month
  130	continue
   12 FORMAT(1X,3A2)
 	DO 78 kdy=idy1,idy2  ! 
		call blet2(kdy,ADY)
 	infile1(22:23)=ADY
	infile2(30:31)=ADY
	write(*,12) ayr,amn,ady
	write(110,12) ayr,amn,ady
 
C UT cycle
	DO 301 iut=0,23
	call blet2(iut,AUT)
	infile1(24:25)=aut
	infile2(32:33)=aut
	OPEN(111,FILE=INFILE1)	  ! 
C   reading map1 for  current month
C
cr	glat=-90.
	sum1=0.
 	DO ilat=1,71 	  ! < LAT-BY-LAT
cr	glat=glat+2.5
	READ (111,107,END=109,ERR=2) (rx(k),k=0,72)
C
cr	glon=-185.		! glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
cr	glon=glon+5.
cr	if (glon.lt.0.) glon=glon+360.
	xmap1(k,ilat)=rx(k)
	sum1=sum1+rx(k)
	enddo
	ENDDO
  109	close(unit=111)
	 sum1=sum1/5183.

	OPEN(112,FILE=INFILE2)	  ! 
C   reading map2 for  current month
C
cr	glat=-90.
	sum2=0.
	rms=0.
 	DO ilat=1,71 	  ! < LAT-BY-LAT
cr	glat=glat+2.5
	READ (112,107,END=110,ERR=2) (rx(k),k=0,72)
C
cr	glon=-185.		! glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
cr	glon=glon+5.
cr	if (glon.lt.0.) glon=glon+360.
	xmap2(k,ilat)=rx(k)
	sum2=sum2+rx(k)
	rms=rms+(xmap1(k,ilat)-rx(k))**2
	enddo
	ENDDO
  110	close(unit=112)
	sum2=sum2/5183.
	rms2=sqrt(rms/5183.)
	write(*,14) iut,sum1,sum2,rms2
	write(110,14) iut,sum1,sum2,rms2
  301	continue
  14  FORMAT(1X,I2,3(1X,F7.3))
   78 continue
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 106	FORMAT(73(1X,I4))	

C
	close(unit=110)
C
	goto 98
   2	write(*,*) 'Error reading data file', infile1,infile2
  98	pause ' '
	stop
  	END
